'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var jsWeb3jsAdapters = require('@lorisleiva/js-web3js-adapters');
var web3_js = require('@solana/web3.js');

class Web3JsTransactionFactory {
  create(input) {
    const web3JsMessage = jsWeb3jsAdapters.toWeb3JsMessageFromInput(input);
    return {
      message: jsWeb3jsAdapters.fromWeb3JsMessage(web3JsMessage),
      serializedMessage: web3JsMessage.serialize(),
      signatures: input.signatures ?? []
    };
  }
  serialize(transaction) {
    return jsWeb3jsAdapters.toWeb3JsTransaction(transaction).serialize();
  }
  deserialize(serializedTransaction) {
    return jsWeb3jsAdapters.fromWeb3JsTransaction(web3_js.VersionedTransaction.deserialize(serializedTransaction));
  }
  serializeMessage(message) {
    return new Uint8Array(jsWeb3jsAdapters.toWeb3JsMessage(message).serialize());
  }
  deserializeMessage(serializedMessage) {
    return jsWeb3jsAdapters.fromWeb3JsMessage(web3_js.VersionedMessage.deserialize(serializedMessage));
  }
}

exports.Web3JsTransactionFactory = Web3JsTransactionFactory;
//# sourceMappingURL=Web3JsTransactionFactory.cjs.map
